function varargout = cgui(varargin)
% CGUI M-file for cgui.fig
%      CGUI, by itself, creates a new CGUI or raises the existing
%      singleton*.
%
%      H = CGUI returns the handle to a new CGUI or the handle to
%      the existing singleton*.
%
%      CGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CGUI.M with the given input arguments.
%
%      CGUI('Property','Value',...) creates a new CGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before cgui_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to cgui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help cgui

% Last Modified by GUIDE v2.5 21-Aug-2003 18:00:45
% Written by Doug Johnson, August 2003 for UW CSE 457
% $Id: cgui.m,v 1.17 2003/08/22 03:46:16 finson Exp $

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @cgui_OpeningFcn, ...
                   'gui_OutputFcn',  @cgui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before cgui is made visible.
function cgui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to cgui (see VARARGIN)

% Choose default command line output for cgui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% This sets up the initial plot - only do when we are invisible
% so window can get raised using cgui.
if strcmp(get(hObject,'Visible'),'off')
    handles.local_limits = [0 2 0 2 0 2];
    handles.local_ticks = [0:.5:2];
    handles.global_limits = [-5 5 -5 5 0 2];
    handles.global_ticks = [-5:1:5];
    
    handles.frame = [ 0 1 0 0; 0 0 0 1; 1 1 1 1];
    
    handles.points = zeros(3,0);
    handles.matrix = eye(3);

    handles.hPoints = zeros(3,8);
    handles.hPoints(:,1:4) = [ ...
        handles.x1 handles.x2 handles.x3 handles.x4; ...
        handles.y1 handles.y2 handles.y3 handles.y4; ...
        handles.z1 handles.z2 handles.z3 handles.z4];
    handles.hPoints(:,5:8) = [ ...
        handles.x5 handles.x6 handles.x7 handles.x8; ...
        handles.y5 handles.y6 handles.y7 handles.y8; ...
        handles.z5 handles.z6 handles.z7 handles.z8];

    handles.hMatrix = zeros(3,3);
    handles.hMatrix = [...
       handles.m_11 handles.m_12 handles.m_13; ...
       handles.m_21 handles.m_22 handles.m_23; ...
       handles.m_31 handles.m_32 handles.m_33];
    
    % values associated with each transform matrix
    handles.hMatrices = zeros(3,3,3);
    handles.hMatrices(:,:,1) = [ ...
        handles.ma_11 handles.ma_12 handles.ma_13; ...
        handles.ma_21 handles.ma_22 handles.ma_23; ...
        handles.ma_31 handles.ma_32 handles.ma_33];
    handles.hMatrices(:,:,2) = [ ...
        handles.mb_11 handles.mb_12 handles.mb_13; ...
        handles.mb_21 handles.mb_22 handles.mb_23; ...
        handles.mb_31 handles.mb_32 handles.mb_33];
    handles.hMatrices(:,:,3) = [ ...
        handles.mc_11 handles.mc_12 handles.mc_13; ...
        handles.mc_21 handles.mc_22 handles.mc_23; ...
        handles.mc_31 handles.mc_32 handles.mc_33];

    % controls associated with each transform matrix:
    %   operation label, set-to-identity button, enable box
    handles.hControls = [ ...
        handles.enable_ma handles.equal_label handles.reset_ma; ...
        handles.enable_mb handles.star_label_mb handles.reset_mb; ...
        handles.enable_mc handles.star_label_mc handles.reset_mc;];

    % handles to the local reference frame in the global axes
    handles.hFrame = [];
     
    guidata(hObject, handles);
    
    set_matrix_visible(hObject,1)
    set_matrix_visible(hObject,2)
    set_matrix_visible(hObject,3)
    set_homogeneous_visible(hObject)

    disable_points(hObject)
    draw_local(hObject)
    draw_global(hObject)
    draw_transformed_frame(hObject)
end

% UIWAIT makes cgui wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = cgui_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --------------------------------------------------------------------
function FileMenu_Callback(hObject, eventdata, handles)
% hObject    handle to FileMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function OpenMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to OpenMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
file = uigetfile('*.fig');
if ~isequal(file, 0)
    open(file);
end

% --------------------------------------------------------------------
function PrintMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to PrintMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
printdlg(handles.figure1)

% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
                     ['Close ' get(handles.figure1,'Name') '...'],...
                     'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

delete(handles.figure1)

% --------------------------------------------------------------------
% --- Executes during m_rc object creation, after setting all properties.
function m_rc_CreateFcn(hObject, eventdata, handles)
% hObject    handle to m_rc component (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --------------------------------------------------------------------

function draw_points_Callback(hObject, eventdata, handles)
% hObject    handle to draw_points (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
draw_transformed_points(hObject)
return
% --------------------------------------------------------------------

function clear_points_Callback(hObject, eventdata, handles)
disable_points(hObject)
draw_local(hObject)
return

% --------------------------------------------------------------------
% --- Executes during mx_rc object creation, after setting all properties.
function mx_rc_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --------------------------------------------------------------------
function mx_rc_Callback(hObject, eventdata, handles)
% hObject    handle to object (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of object as text
%        str2double(get(hObject,'String')) returns contents of object as a double
update_transform(hObject)
draw_transformed_frame(hObject)

% --------------------------------------------------------------------

% --- Executes on button press in clear_image.
function clear_image_Callback(hObject, eventdata, handles)
% hObject    handle to clear_image (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
draw_global(hObject)
draw_transformed_frame(hObject)
return

% --------------------------------------------------------------------
% --- Executes on button press in enable_ma.
% This should never happen.  enable_ma is set to enabled and not visible.
function enable_ma_Callback(hObject, eventdata, handles)
beep
return

% --------------------------------------------------------------------
% --- Executes on button press in enable_mb.
function enable_mb_Callback(hObject, eventdata, handles)
set_matrix_visible(hObject,2)
draw_transformed_frame(hObject)
return

% --------------------------------------------------------------------
% --- Executes on button press in enable_mc.
function enable_mc_Callback(hObject, eventdata, handles)
set_matrix_visible(hObject,3)
draw_transformed_frame(hObject)
return

% --------------------------------------------------------------------

function set_matrix_visible(hObject,idx)
% hObject    handle to some figure or component
% idx        the index of the matrix to set
handles = guidata(hObject);
if get(handles.hControls(idx,1),'Value') == 0
    flag = 'off';
    notflag = 'on';
else
    flag = 'on';
    notflag = 'off';
end
for i=1:2
    for j=1:2
        set(handles.hMatrices(i,j,idx),'Visible',flag)
    end
end
if get(handles.enable_homogeneous,'Value')
    set(handles.hMatrices(1,3,idx),'Visible',flag)
    set(handles.hMatrices(2,3,idx),'Visible',flag)
    set(handles.hMatrices(3,1,idx),'Visible',flag)
    set(handles.hMatrices(3,2,idx),'Visible',flag)
    set(handles.hMatrices(3,3,idx),'Visible',flag)
else
    set(handles.hMatrices(1,3,idx),'Visible','off')
    set(handles.hMatrices(2,3,idx),'Visible','off')
    set(handles.hMatrices(3,1,idx),'Visible','off')
    set(handles.hMatrices(3,2,idx),'Visible','off')
    set(handles.hMatrices(3,3,idx),'Visible','off')
end
set(handles.hControls(idx,2),'Visible',flag)
set(handles.hControls(idx,3),'Visible',flag)
if idx < size(handles.hControls,1)
    set(handles.hControls(idx+1,1),'Visible',flag)
end
if idx > 2
    set(handles.hControls(idx-1,1),'Enable',notflag)
end
guidata(hObject, handles)
set_matrix_identity(hObject,idx)
return

% --------------------------------------------------------------------
% --- Executes on button press in enable_homogeneous.
function enable_homogeneous_Callback(hObject, eventdata, handles)
set_homogeneous_visible(hObject)
draw_transformed_frame(hObject)

% --------------------------------------------------------------------
% --- Executes on button press in reset_ma, reset_mb, or reset_mc.
% Reset the indicated transformation matrix to identity.

function reset_mx_Callback(hObject, eventdata, handles)
idx = 1;
if hObject == handles.reset_mb
    idx = 2;
elseif hObject == handles.reset_mc
    idx = 3;
end
set_matrix_identity(hObject,idx)
draw_transformed_frame(hObject)
return

% --------------------------------------------------------------------
% hObject    handle to some figure or component
% idx        the index of the matrix to set
function set_matrix_identity(hObject,idx)
handles = guidata(hObject);
for i = 1:3
    for j = 1:3
        if i==j
            set(handles.hMatrices(i,j,idx),'String','1')
        else
            set(handles.hMatrices(i,j,idx),'String','0')
        end
    end
end
guidata(hObject, handles)
update_transform(hObject)
return

% --------------------------------------------------------------------

function disable_points(hObject)
handles = guidata(hObject);
for i = 1:size(handles.hPoints,1)
    for j = 1:size(handles.hPoints,2)
        set(handles.hPoints(i,j),'Visible','off')
    end
end
guidata(hObject, handles)
get_points(hObject)
return

% --------------------------------------------------------------------

function n = count_points(hObject)
handles = guidata(hObject);
for n = size(handles.hPoints,2):-1:1
    if strcmp(get(handles.hPoints(1,n),'Visible'),'on')
        return
    end
end
n = 0;
return

% --------------------------------------------------------------------
% This method should be called each time the current set of points
% is changed.  This way, handles.points is always up to date.

function get_points(hObject)
n = count_points(hObject);
handles = guidata(hObject);

handles.points = zeros(3,n);

for j = 1:n
    [x c] = sscanf(get(handles.hPoints(1,j),'String'),'%f');
    [y c] = sscanf(get(handles.hPoints(2,j),'String'),'%f');
    [z c] = sscanf(get(handles.hPoints(3,j),'String'),'%f');
    handles.points(:,j) = [x y z]';
end
guidata(hObject, handles)
return

% --------------------------------------------------------------------
% Update the tranformation matrix
function update_transform(hObject)
handles = guidata(hObject);

handles.matrix = eye(3);
for idx = 1:3
    A = [ ...
        str2num(get(handles.hMatrices(1,1,idx),'String')) ...
        str2num(get(handles.hMatrices(1,2,idx),'String')) ...
        str2num(get(handles.hMatrices(1,3,idx),'String')); ...
        str2num(get(handles.hMatrices(2,1,idx),'String')) ...
        str2num(get(handles.hMatrices(2,2,idx),'String')) ...
        str2num(get(handles.hMatrices(2,3,idx),'String')); ...
        str2num(get(handles.hMatrices(3,1,idx),'String')) ...
        str2num(get(handles.hMatrices(3,2,idx),'String')) ...
        str2num(get(handles.hMatrices(3,3,idx),'String'))]; 
    handles.matrix = handles.matrix * A;
end
for i=1:3
    for j=1:3
        set(handles.hMatrix(i,j),'String',sprintf('%3.1f',handles.matrix(i,j)))
    end
end
guidata(hObject, handles)
return

% --------------------------------------------------------------------
% Draw the currently defined points in the local axes

function draw_local(hObject)
handles = guidata(hObject);
axes(handles.local_axes);
cla reset
set(handles.local_axes,'ButtonDownFcn',@local_axes_ButtonDownFcn)
axis(handles.local_limits)
axis equal
axis manual
view(2)
set(gca,'XTick',handles.local_ticks)
set(gca,'YTick',handles.local_ticks)
set(gca,'ZTick',[0 1 2])
hold on
plot3(handles.points(1,:)',handles.points(2,:)',handles.points(3,:)','b')
set(findobj(gca,'Type','line'),'HitTest','off')
guidata(hObject, handles)
return

% --------------------------------------------------------------------
% --- Executes on mouse press over axes background.
function local_axes_ButtonDownFcn(hObject, eventdata)
% hObject    handle to local_axes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB

handles = guidata(hObject);

% ignore click if we already have max number of points

n = count_points(hObject);
if n >= size(handles.hPoints,2)
    return
end

% get info about the click point and store it

cp = get(hObject,'CurrentPoint');
x = cp(1,1);
y = cp(1,2);
z = 1;

set(handles.hPoints(1,n+1),'String',sprintf('%3.1f',x))
set(handles.hPoints(2,n+1),'String',sprintf('%3.1f',y))
set(handles.hPoints(3,n+1),'String',sprintf('%3.1f',z))
set(handles.hPoints(1,n+1),'Visible','on')
set(handles.hPoints(2,n+1),'Visible','on')
if get(handles.enable_homogeneous,'Value')
    set(handles.hPoints(3,n+1),'Visible','on')
end

guidata(hObject, handles)

% draw the newly updated object

get_points(hObject)
draw_local(hObject)
return

% --------------------------------------------------------------------
% Draw the local frame of reference as transformed to global coordinates

function draw_transformed_frame(hObject)
handles = guidata(hObject);
axes(handles.global_axes);
if length(handles.hFrame) > 0
    for i = 1:length(handles.hFrame)
        delete(handles.hFrame(i))
    end
end
handles.hFrame = [];
A = handles.matrix * handles.frame;
handles.hFrame(1) = plot3(A(1,1:2)',A(2,1:2)',A(3,1:2)',':b');
handles.hFrame(2) = plot3(A(1,3:4)',A(2,3:4)',A(3,3:4)',':b');
guidata(hObject, handles)
return

% --------------------------------------------------------------------
% Draw the current set of points as transformed to global coordinates

function draw_transformed_points(hObject)
handles = guidata(hObject);
axes(handles.global_axes);
A = handles.matrix * handles.points;
plot3(A(1,:)',A(2,:)',A(3,:)','b');
guidata(hObject, handles)
return

% --------------------------------------------------------------------
% Draw the global axes

function draw_global(hObject)
handles = guidata(hObject);
axes(handles.global_axes)
cla reset
axis(handles.global_limits)
axis equal
axis manual
view(2)
set(gca,'XTick',handles.global_ticks)
set(gca,'YTick',handles.global_ticks)
set(gca,'ZTick',[0 1 2])
hold on
plot3(handles.frame(1,1:2)',handles.frame(2,1:2)',handles.frame(3,1:2)','r');
plot3(handles.frame(1,3:4)',handles.frame(2,3:4)',handles.frame(3,3:4)','r');
handles.hFrame = [];
guidata(hObject, handles)
return

% --------------------------------------------------------------------
% Change the visibility of the z-coordinates

function set_homogeneous_visible(hObject)
% hObject    handle to some figure or component
handles = guidata(hObject);
if get(handles.enable_homogeneous,'Value') == 0
    flag = 'off';
else
    flag = 'on';
end

% Combined transformation matrix
set(handles.hMatrix(1,3),'Visible',flag)
set(handles.hMatrix(2,3),'Visible',flag)
set(handles.hMatrix(3,1),'Visible',flag)
set(handles.hMatrix(3,2),'Visible',flag)
set(handles.hMatrix(3,3),'Visible',flag)

% Each individual transformation matrix
for idx=1:size(handles.hControls,1)
    if get(handles.hControls(idx,1),'Value')
        set(handles.hMatrices(1,3,idx),'Visible',flag)
        set(handles.hMatrices(1,3,idx),'String','0')
        set(handles.hMatrices(2,3,idx),'Visible',flag)
        set(handles.hMatrices(2,3,idx),'String','0')
        set(handles.hMatrices(3,1,idx),'Visible',flag)
        set(handles.hMatrices(3,2,idx),'Visible',flag)
        set(handles.hMatrices(3,3,idx),'Visible',flag)
    end
end

% bottom row of the points
for j = 1:count_points(hObject)
    set(handles.hPoints(3,j),'Visible',flag)
end
set(handles.z_label,'Visible',flag)

guidata(hObject, handles)
update_transform(hObject)
return